/*********************************************************************
 * Original Code--                                                   *
 * AberChat Client 4.20 (C) Giancarlo Castrataro -- iDirt/Compatible *
 *   Thanks Kroll@SMiLE for letting Merc use this code               *
 * Release of Aberchat Client for Merc 2.02 (C) Derek Bryan          *
 *                                    Merc/Diku/Circle Compatible    *
 *********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <unistd.h>
#include <ctype.h>
#include <netinet/in.h>
#include <string.h>
#include <time.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <netdb.h>
#include "merc.h"
#include "client_int.h"

bool noarg2 = FALSE;
bool nobackground = FALSE;
bool auto_restart = TRUE;
bool auth = FALSE;
bool aber_output = FALSE;
int aberfd = -1;
char abuffer[WRITELEN];
char *lastawho;
int awhocount;
void	note_attach	args( ( CHAR_DATA *ch ) );

time_t boottime = 0;            /* when we opened the socket to the server */
time_t socktime = 0;            /* the last time anything went in or out on the socket */

char *abermail_store args( (char *from, char *frommud, char *to, char *subject, char *date, char *data) );
bool	is_note_to	args( ( CHAR_DATA *ch, NOTE_DATA *pnote ) );

static char *diku2aberTransTbl[] = { "nrbgpycw", "lrbgmycw" };

static char *aber2dikuTransTbl[] = { "lrbgmycw", "nrbgpycw" };


char *aber2diku(const char *src)
{
    static char *dest;
    char data[3], *p;
	int i, j, len = strlen(src), size;

	if(dest) free(dest);
	dest = malloc(size = len + 1);
	for(i = j = 0; i < len; i++)
    {
	if(src[i] != '&')
	{
        data[0] = src[i];
	    if (src[i] == '#')
	    {
	      data[1] = src[i];
	      data[2] = 0;
	    }
      else
			data[1] = 0;
		}
	else
	{
        if(src[i + 1] == '*') 
        {
           strcpy(data, "#-");
           i++;
        }
        else if(!(p = strchr(aber2dikuTransTbl[0], tolower(src[i + 2])))
            ||( src[i + 1] != '+' && src[i + 1] != '='))
        {
           data[0] = src[i];
           data[1] = 0;
        }
	    else
	    {
		if (src[i + 1] == '=') nobackground = TRUE;
		strcpy(data, "#");
		++i;
		data[1] = aber2dikuTransTbl[1][(int)(p - aber2dikuTransTbl[0])];
		if(isupper(src[++i])) data[1] = toupper(data[1]);
		data[2] = 0;
		if (nobackground)
		{
		  ++i;
		  nobackground = FALSE;
		}
		}
	}
		if(j + strlen(data) >= size) dest = realloc(dest, size += len);
  	        strcpy(dest + j, data);
		j += strlen(data);
	}
	return dest;
}

char *diku2aber(const char *src)
{
    static char *dest;
	char data[4], *p;
	int i, j, len = strlen(src), size;

	if(dest) free(dest);
	dest = malloc(size = len + 1);
	for(i = j = 0; i < len; i++)
    {

		if(src[i] != '#')
	{
			data[0] = src[i];
			data[1] = 0;
		}
	else
	{
    if(!(p = strchr(diku2aberTransTbl[0], tolower(src[i + 1]))))
	    {

	       if(src[i + 1] == '-') 
	       {
		    strcpy(data, "&*");
                    ++i;
           }
		else
		{
					data[0] = src[i];
					data[1] = 0;
		    if (src[i + 1] == '#')
		    {
		      ++i;
		    }
				}
			}
	    else
	    {
				strcpy(data, "&+");
				data[2] = diku2aberTransTbl[1][(int)(p - diku2aberTransTbl[0])];
				if(isupper(src[++i])) data[2] = toupper(data[2]);
				data[3] = 0;
			}
		}
		if(j + strlen(data) >= size) dest = realloc(dest, size += len);
		strcpy(dest + j, data);
		j += strlen(data);
	}
	return dest;
}


void striptext2 ( const char *txt, char *out_buffer)
{
    int i;   /* index into 'txt', which is the input string */
    int j;   /* index into 'out_buffer' */
    noarg2 = FALSE;
    for ( i=j=0; txt[i] != '\0'; )
    {
	if ( txt[i] != '@' )
	{
	    out_buffer[j++] = txt[i++];     /* just copy one character */
	}
	else    /* translate '#<n>' into ANSI escape sequence */
	{
	    out_buffer[j] = '\0';
	    return;
	}
    }
    noarg2 = TRUE;
}

void striptext3 (const char *txt, char *out_buffer)
{
    int i;
    int j;
    for ( i=j=0; txt[i] != '\0'; )
    {
        if (txt[i] != ' ')
            out_buffer[j++] = txt[i++];
        else break;
    }
    out_buffer[j] = '\0';
    return;
}

void striptext ( const char *txt, char *out_buffer)
{
    int i;   /* index into 'txt', which is the input string */
    int j;   /* index into 'out_buffer' */

    for ( i=j=0; txt[i] != '\0'; )
    {
	if ( txt[i] != '\x1b' )
	{
	    out_buffer[j++] = txt[i++];     /* just copy one character */
	}
	else    /* translate '#<n>' into ANSI escape sequence */
	{
	    break;
	}
    }
    out_buffer[j] = '\0';
}


CHAR_DATA *get_all_world( char *argument )
{
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *wch;
    int number;
    int count;

    number = number_argument( argument, arg );
    count  = 0;
    for ( wch = char_list; wch != NULL ; wch = wch->next )
    {
	if ( !IS_NPC(wch) && IS_HEAD(wch, LOST_HEAD) ) continue;
	else if ( !IS_NPC(wch) && IS_EXTRA(wch, EXTRA_OSWITCH) ) continue;

    else if ( str_prefix( arg, wch->name )
      && ( IS_NPC(wch) || !is_name( arg, wch->morph )))
	    continue;

	if ( ++count == number )
	    return wch;
    }
    return NULL;
}



int makesock(char *addr, int port)
{
  int s;
  int opt = 1;
  struct hostent *host;
  struct sockaddr_in client;

  if ((host = gethostbyname(addr)) == NULL)
  {
    return -1;
  }
  client.sin_family = AF_INET;
  client.sin_port = htons(port);
  client.sin_addr = (*(struct in_addr *) host->h_addr_list[0]);

  if ((s = socket(AF_INET, SOCK_STREAM, 0)) == -1)
  {
    return -1;
  }
  if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *) &opt, sizeof(opt)) == -1)
  {
    close(s);
    return -1;
  }
  if (connect(s, (struct sockaddr *) &client, sizeof(client)) == -1)
  {
    close(s);
    return (-1);
  }
  if (fcntl(s, F_SETFL, O_NONBLOCK) == -1)
  {
    close(s);
    return -1;
  }


  return (s);
}

int oldsock(void)
{
    FILE *fp;
    int extra;
    int aoutput;
    char abuff[WRITELEN];

    fp = fopen(INSETFILE, "r");
    if (fp)
    {
       fscanf(fp, "%d %s %d %ld\n", &extra, abuff, &aoutput, &boottime);
       if (extra == -1) return -1;
       else 
       {
           sprintf(abuffer, "%s", abuff);
           aber_output = aoutput;
           return(extra);
       }
    }
    else return -1;
}

int aberchat_boot( bool fCopyOver )
{
    if (fCopyOver)
    {
      aberfd = oldsock();
      if (aberfd != -1)
      {
          auth = TRUE;
	  aprintf(" ");
          return 2;
      }
      else log_string("CopyOver AberChat: ERROR");
    }

  if (aberfd == -1)
  {

    if ((aberfd = makesock(SERVER, SERVER_PORT)) == -1)
    {
      return 0;
    }
    else
    {
/********************************/
      FILE *fp;
      int extra;
      long btime;
      int aoutput;
      char *abuff;
      extra = aberfd;
      btime = boottime;
      aoutput = aber_output;
      abuff = abuffer;
      fp = fopen (INSETFILE, "w");

      fprintf(fp, "%d %s %d %ld\n", extra, abuff, aoutput, boottime);
      fprintf(fp, "-1");
    
      fclose(fp);
/******************************/

      authenticate();
      time(&socktime);
      time(&boottime);
      return 1;
    }
  }
  return 2;
}
/* Pops one argument from a string */

char *get_arg(char *txt)
{
  char *ptr;

  if (txt != NULL && (ptr = strchr(txt, DCHAR)))
  {
    *ptr = 0;
    return (++ptr);
  }
  else
    return (NULL);
}

char *get_arg2(char *txt)
{
  char *ptr;

  if (txt != NULL && (ptr = strchr(txt, *"@")))
  {
    *ptr = 0;
    return (++ptr);
  }
  else
    return '\0';
}

char *get_arg3(char *txt)
{
  char *ptr;

  if (txt != NULL && (ptr = strchr(txt, *" ")))
  {
    *ptr = 0;
    return (++ptr);
  }
  else
    return '\0';
}

bool aberchat_shutdown(void)
{
  if (aberfd != -1)
  {
    log_string("ABERCHAT: Shutdown");
    close(aberfd);
    aberfd = -1;
    return TRUE;
  }
  return FALSE;
}

void aberchat_autorecon(void)
{
  log_string("ABERCHAT: auto reconnect");
  aberchat_boot( fCopyOver );
  return;
}

/* a little function to print out the aberchat socket details in a format
 * that would fit in nicely with socketcom in god.c
 */

void aberchat_writepacket(void)
{
  if (aber_output)
  {
    char *colbuffer = diku2aber(abuffer);
    write(aberfd, colbuffer, strlen(colbuffer) + 1);
    *abuffer = 0;
    aber_output = FALSE;
    time(&socktime);
  }
  return;
}

void aprintf(char *format,...)
{
  char buffer[WRITELEN];
  bool ok = FALSE;
  va_list pvar;


  {
    if (aberfd == -1)
      return;
    else
      ok = TRUE;
  }

  if (ok)
  {
    va_start(pvar, format);
    vsprintf(buffer, format, pvar);
    va_end(pvar);
    strcat(abuffer, buffer);
    aber_output = TRUE;
  }
  return;
}

void amudlist(char *packet)
{
  CHAR_DATA *victim;
  char *player, *mudname, *mudlib, *mudaddr, *mudip, *mudport, *next;
  char to_plr[MAX_STRING_LENGTH];
  char buf[MAX_STRING_LENGTH];

  player = packet;
  next = get_arg(player);

  striptext(player, to_plr);

  if ( (victim = ( get_all_world( to_plr ) ) ) == NULL)
      return;

  sprintf(buf, "\n\r#RMudname         #rAddress                     #RIP              #rPort  #RCode Base\n\r" DASHES);
  send_to_char(buf,victim);

  while (next != NULL)
  {
     mudname = next;
     mudlib = get_arg(mudname);
     mudaddr = get_arg(mudlib);
     mudip = get_arg(mudaddr);
     mudport = get_arg(mudip);
     next = get_arg(mudport);
     sprintf(buf, "%-15.15s %-27.27s %-15.15s %-5s %-13.13s\n\r",
     mudname, mudlib, mudaddr, mudip, mudport);
     send_to_char(buf,victim);

  }
  sprintf(buf, "%s\n\r", DASHES);
  send_to_char(buf,victim);
}


void kick_player(char *from, char *to, char *frommud)
{
   CHAR_DATA *victim;
   char buf[MAX_STRING_LENGTH];
   if ( (victim = ( get_all_world( to ) ) ) == NULL)
   {
       aprintf("%c" D "%s" D "%c" D "%s" D "MUD %s" D "%s is not online",
	  TO_MUD, frommud, MSG, from, MYMUD, to);
   }
   else if (victim->level > 11)
   {
       aprintf("%c" D "%s" D "%c" D "%s" D "MUD %s" D "%s is too powerful",
	  TO_MUD, frommud, MSG, from, MYMUD, to);
   }
   else
   {
      sprintf(buf, "You have been kicked off aberchat by %s@%s\n", from, frommud);
      send_to_char(buf, victim);
      if (!IS_SET(victim->stuff[1], ACHAT_BAN))
	SET_BIT(victim->stuff[1], ACHAT_BAN);
      sprintf(buf,"ABERCHAT: %s has been akicked by %s@%s.", victim->name, from, frommud);
      log_string(buf);
   }
}

void aberchat_readpacket(void)
{
  static char buff[READLEN];
  static char *pos = buff;
  int n_read, data_type;

  n_read = read(aberfd, pos, READLEN - (pos - buff));

  if (n_read <= 0)
  {
    if (aberfd != -1 && buff == '\0')
    {
      log_string("ABERCHAT: Connection closed by Server.");
      aberchat_shutdown();
    }
  }
  else
  {
  if (*(pos + n_read - 1) == 0)
  {
    data_type = *buff;
    abercmd(*buff, buff + 2);
    *buff = 0;
    pos = buff;
  } 
  else
  {
    pos += n_read;
  }
  }
  time(&socktime);
  return;
}

bool canchat(CHAR_DATA *victim)
{
  if (IS_SET(victim->stuff[1], NO_ACHAT) || IS_SET(victim->stuff[1], ACHAT_BAN))
     return FALSE;
  else return TRUE;
}

void aberchat_sendmail(char *from, char *to_list, char *subject, char *date, char *data)
{
  char *to;
  char tomud[MAX_STRING_LENGTH];
  char argme[MAX_STRING_LENGTH];
  striptext2(to_list,argme);
  if (noarg2)
  {
    return;
  }
  to = get_arg2(to_list);
  to = one_argument(to, tomud);
  to = to_list;
if ( to[0] != '\0' && tomud[0] != '\0' ) {
  aprintf("%c" D "%s" D "%c" D "%s" D "%s" D "%s" D "%s" D "%s" D "%s",
			TO_MUD, tomud, ABERMAIL, from, MYMUD, to, subject, date, data);
  }
}

void receive_abermail(char *packet)
{
	char *frommud, *from, *to, *subject, *date, *data, *rval;
        char newfrommud[MAX_STRING_LENGTH];
	from = packet;
	frommud = get_arg(from);
	to = get_arg(frommud);
	subject = get_arg(to);
	date = get_arg(subject);
	data = get_arg(date);

	rval = abermail_store(from, frommud, to, subject, date, data);
        frommud[strlen(frommud)] = '\0';
        newfrommud[0] = '\0';
        striptext3( frommud, newfrommud);
        newfrommud[strlen(newfrommud)] = '\0';
//        log_string( newfrommud );
        if (rval) {
		aprintf("%c" D "%s" D "%c" D "%s" D "MUD %s" D "%s",
                                TO_MUD,
				newfrommud,
				MSG,
				from,
				MYMUD,
				rval);
	}
}

char *abermail_store(char *from, char *frommud, char *to, char *subject, char *date, char *data)
{
   NOTE_DATA *chpnote;
   NOTE_DATA *pnote;
   char sender[MAX_STRING_LENGTH];
   FILE *fp;
   char *strtime;
   DESCRIPTOR_DATA *d;

   sprintf(sender, "%s@%s", from, frommud);
   strtime	= ctime( &current_time );
   strtime[strlen(strtime)-1]	= '\0';
   to[strlen(to)] = '\0';

   if ( note_free == NULL )
   {
      chpnote	  = alloc_perm( sizeof(*chpnote) );
   }
   else
   {
      chpnote = note_free;
      note_free = note_free->next;
   }

   chpnote->subject = str_dup( subject );
   chpnote->to_list = '\0';
   chpnote->to_list = str_dup( to );
   chpnote->text = str_dup( data );
   chpnote->date = str_dup( strtime );
   chpnote->sender = str_dup( sender );

        if ( note_list == NULL )
	{
	    note_list	= chpnote;
	}
	else
	{
            for ( pnote = note_list; pnote->next != NULL; pnote = pnote->next )
		;
	    pnote->next	= chpnote;
	}
	pnote		= chpnote;
	chpnote	= NULL;
        fclose( fpReserve );
	if ( ( fp = fopen( NOTE_FILE, "a" ) ) == NULL )
	{
	    perror( NOTE_FILE );
	}
	else
	{
		    fprintf( fp, "Sender  %s~\nDate    %s~\nTo      %s~\nSubject %s~\nText\n%s~\n\n",
			pnote->sender,
			pnote->date,
			pnote->to_list,
			pnote->subject,
			pnote->text
			);
		fclose( fp );
        }
        fpReserve = fopen( NULL_FILE, "r" );
            for ( d = descriptor_list; d != NULL; d = d->next )
    {
    CHAR_DATA *och;
    CHAR_DATA *vch;

    och = d->original ? d->original : d->character;
    vch = d->character;
    if ( d->connected != CON_PLAYING ) continue;

    if ( is_note_to( vch, pnote ) )

    send_to_char("A new note has been posted\n\r", vch);

    }

        return "Mail Sent.";
//        else return "There was an error.";
}

/* Prototype: FROM_PLAYER:TO_PLAYER:FROM_MUD:TEXT */


void atell(char *f_plr, char *to_plr, char *f_mud, char *text)
{
  char buf[MAX_STRING_LENGTH];
  CHAR_DATA *victim;
  char outbuff[MAX_STRING_LENGTH];

  if ((victim = get_all_world( to_plr )) != NULL)
  {
    if (canchat(victim))
    {
       sprintf(buf, "#r%s#R@#r%s tells you#R:#r %s\n\r", f_plr, f_mud, text);
       striptext3(f_mud, outbuff);
       send_to_char(buf,victim);
       sprintf(buf, "%s@%s", f_plr, outbuff);
       free_string(victim->unused2);
       victim->unused2 = str_dup( buf );
       return;
    }
    else
    {
    aprintf("%c" D "%s" D "%c" D "%s" D "MUD %s" D "%s cannot receive atells.",
        TO_MUD, f_mud, MSG, f_plr, MYMUD, to_plr);
    return;
    }

  }
  else
  {
    aprintf("%c" D "%s" D "%c" D "%s" D "MUD %s" D "%s is not online",
        TO_MUD, f_mud, MSG, f_plr, MYMUD, to_plr);
  }


}

void aver_reply(char *tomud, char *player)
{
  aprintf("%c" D "%s" D "%c" D "%s" D "%s",
     TO_MUD, tomud, AVERSION, player, CLIENT_VERSION);
}

void aversion(char *to_plr, char *client_ver, char *server_ver)
{
   CHAR_DATA *victim;
   char buf[MAX_STRING_LENGTH];
   if ((victim = get_all_world(to_plr)) == NULL)
      return;

   sprintf(buf, "Server is: %s\n\rClient is: %s\n\r           Based on the original Client 4.20 (pl 7)\n\rAdapted by Derek Z. Bryan (August 7, 1999)\n\rClient and Server Code Copyright G. Castrataro (gcastrat@indiana.edu)\n\r", server_ver, client_ver);
   send_to_char(buf, victim);
}



void amessage(char *to_plr, char *f_mud, char *text)
{
  char buf[MAX_STRING_LENGTH];
  CHAR_DATA *victim;

   if ( (victim = ( get_all_world( to_plr ) ) ) == NULL)
      return;

   if (canchat(victim))
   {
       sprintf(buf, "#rAMessage from #R%s#r:#R %s\n\r", f_mud, text);
       send_to_char(buf,victim);
       return;
   }
}


void ainfo(char *f_mud, char *text)
{
  char ctl[MAX_STRING_LENGTH];
  DESCRIPTOR_DATA *d;

    sprintf(ctl, "#R<#rAInfo #R%s#r: %s#R>\n\r", f_mud, text);

    for ( d = descriptor_list; d != NULL; d = d->next )
    {
    CHAR_DATA *och;
    CHAR_DATA *vch;

    och = d->original ? d->original : d->character;
    vch = d->character;
    if ( d->connected != CON_PLAYING ) continue;

    if (!canchat(vch)) continue;

    send_to_char(ctl, vch);

    }
}



void achat(int type, char *f_mud, char *f_plr, char *text)
{
  BAN_DATA *pban;
  char ctl[MAX_STRING_LENGTH];
  bool aemote = FALSE;
  DESCRIPTOR_DATA *d;
  if (text[0] == ':')
  {
     text++;
     aemote = TRUE;
  }
    for ( pban = ban_list; pban != NULL; pban = pban->next )
    {
        if ( !str_cmp( pban->name, f_plr ) )  return;
    }
    for ( d = descriptor_list; d != NULL; d = d->next )
    {
    CHAR_DATA *och;
    CHAR_DATA *vch;

    och = d->original ? d->original : d->character;
    vch = d->character;

    if ( d->connected != CON_PLAYING ) continue;

    if (!canchat(vch)) continue;

    switch(type)
    {
      case ACODE:
	if (vch->level < 12)
	continue;
	if (aemote)
	    sprintf(ctl, "#g*#GACODE#g* #G%s#g@#G%s %s#-\n\r", f_plr, f_mud, text);
	else
	    sprintf(ctl, "#g*#GACODE#g* #G%s#g@#G%s#g:#G %s#-\n\r", f_plr, f_mud, text);
	break;
      case AGOD:
	if (vch->level < 7)
	continue;
	if (aemote)
	    sprintf(ctl, "#c(#CAGOD#c) #C%s#c@#C%s %s#-\n\r", f_plr, f_mud, text);
	else
	    sprintf(ctl, "#c(#CAGOD#c) #C%s#c@#C%s#c:#C %s#-\n\r", f_plr, f_mud, text);
	   
	break;
      case CHAT:
	if (aemote)
	    sprintf(ctl, "#r[#R%s#r@#R%s %s#r]#-\n\r", f_plr, f_mud, text);
	else
	    sprintf(ctl, "#r[#R%s#r@#R%s#r]:#R %s#-\n\r", f_plr, f_mud, text);
	break;
    }
    send_to_char(ctl, vch);
    }
}


/***************************************************************************
 * To connect to the network, authenticate() sends a packet which contains *
 * the password, mudname, mudlib, and port.  This allows the server to     *
 * build a mudlist entry for the connecting mud.  Following function is a  *
 * server response, which enables the mud to send data over aberchat       *
 ***************************************************************************/

void authenticate(void)
{
  char passwd[30];

  strcpy(passwd, PASS);
  auth = TRUE;
  aprintf("%c" D "%s" D "%c" D "%s" D "%s" D "%d" D "%s",
      TO_MUD, MYMUD, AUTH, MYMUD, MUDLIB, PORT, passwd);
  auth = FALSE;
}

void auth_received(bool ok)
{
  if (ok)
  {
    auth = TRUE;
    log_string("ABERCHAT: Successful connection to server");
  }
  else
  {
    log_string("ABERCHAT: Connection failed (Bad password)");
    aberchat_shutdown();
  }
}

void receive_awho(char *packet)
{
  CHAR_DATA *ch;
  char buf[MAX_STRING_LENGTH];
  char *player, *name, *level, *title, *mud, *next;
  char to_plr[MAX_STRING_LENGTH];
  int i;

  player = packet;
  mud = get_arg(player);
  next = get_arg(mud);

  striptext(player,to_plr);

  if (char_exists(TRUE,to_plr))
  {
    ch = get_all_world( to_plr );
  }
  else return;

  if (!next)
  {
    sprintf(buf, "There are no players online at %s.\n\r", mud);
    send_to_char(buf,ch);
    return;
  }

  sprintf(buf, "\n\r#RName          #rLevel          #RTitle\n\r" DASHES);
  send_to_char(buf,ch);
  for (i = 0; next; i++)
  {
    name = next;
    level = get_arg(name);
    title = get_arg(level);
    next = get_arg(title);
    sprintf(buf, "%-14s%-15s%-45.47s\n\r", name, level, title);
    send_to_char(buf,ch);
  }
  sprintf(buf, DASHES "There %s %d player%s on %s.\n\r", (i > 1) ? "are" : "is",
      i, (i > 1) ? "s" : "", mud);
  send_to_char(buf,ch);
}

void clearawho(void)
{
   lastawho = "null";
   awhocount = 0;
}

void send_awho(char *mud, char *player)
{
   bool firstimm = TRUE;
   bool firstmortal = FALSE;

        aprintf("%c" D "%s" D "%c" D "%s" D "%s", TO_MUD, mud, RWHO, player, MYMUD);
        {
        char buf[MAX_STRING_LENGTH];
        char kav[MAX_STRING_LENGTH];
        char openb[5];
        char closeb[5];
        char mage_col[10];
        DESCRIPTOR_DATA *d;
        int i;
        int nMatch;
     
        nMatch = 0;
        for ( i = 12; i >= 0; i -= 1)
        {
        if (i == 6)
        {
           firstimm = FALSE;
           firstmortal = TRUE;
        }

        for ( d = descriptor_list; d != NULL; d = d->next )
        {
        CHAR_DATA *wch;
        char class[MAX_STRING_LENGTH];
        char const *other;
    
        /*
         * Check for match against restrictions.
         * Don't use trust as that exposes trusted mortals.
         */
        if ( d->connected != CON_PLAYING )
            continue;
    
        wch   = ( d->original != NULL ) ? d->original : d->character;
    
        if (IS_SET(wch->act, PLR_WIZINVIS) || IS_SET(wch->act, PLR_INCOG)
           || wch->level != i)
           continue;
        nMatch++;

        other = getclass(wch);
        
        kill_color(other, class);
    
        if ( IS_CLASS(wch, CLASS_VAMPIRE))
        { strcpy( openb, "#R<#r" ); strcpy( closeb, "#R>#-" ); }
        else if ( IS_CLASS(wch,CLASS_MAGE))
        { strcpy( openb, "#P{#W" ); strcpy( closeb, "#P}#-" ); }
        else if ( IS_CLASS(wch, CLASS_ANGEL))
        { strcpy( openb, "#W((#C" ); strcpy( closeb, "#W))#-" ); }
        else if ( IS_CLASS(wch, CLASS_NAGA))
        { strcpy( openb, "#g>#R" ); strcpy( closeb, "#g<" ); }
        else if ( IS_CLASS(wch, CLASS_ZOMBIE))
        { strcpy( openb, "#Y*" ); strcpy( closeb, "#Y*" ); }
        else if ( IS_CLASS(wch, CLASS_GOD))
        { strcpy( openb, "#W(" ); strcpy( closeb, "#W)" ); }
        else if (IS_CLASS(wch, CLASS_NYMPH))
        { strcpy(openb, "#G@"); strcpy(closeb, "#G@" ); }
        else
        { strcpy( openb, "#W[#n" ); strcpy( closeb, "#W]#-" ); }
          {
            if ( IS_CLASS(wch, CLASS_DEMON) && IS_SET(wch->special, SPC_DEMON_LORD) )
            sprintf( kav, " %sDemon Lord%s", openb, closeb );
            else if ( IS_SET(wch->special, SPC_CHAMPION) )
            {
            if (IS_SET(wch->special, SPC_PRINCE) && wch->sex == SEX_FEMALE)
                sprintf( kav, " %sDemon Princess%s", openb, closeb );
            else if (IS_SET(wch->special, SPC_PRINCE))
                sprintf( kav, " %sDemon Prince%s", openb, closeb );
            else if (IS_SET(wch->special, SPC_SIRE))
                sprintf( kav, " %sDemon of %s%s", openb,wch->lord,closeb );
            else
                sprintf( kav, " %sChampion of %s%s", openb,wch->lord,closeb );
            }
        else if ( IS_CLASS(wch, CLASS_ANGEL) && IS_SET(wch->special, SPC_ARCH) )
                sprintf( kav, " %sArch Angel%s", openb, closeb);
        else if (IS_CLASS(wch,CLASS_ANGEL))
            {
        if (IS_SET(wch->special, SPC_PRINCE) && wch->sex == SEX_FEMALE)
                sprintf( kav, " %sAngel Princess%s", openb, closeb );
            else if (IS_SET(wch->special, SPC_PRINCE))
                sprintf( kav, " %sAngel Prince%s", openb, closeb );
        else sprintf(kav, " %sAngel of %s%s", openb, wch->lord, closeb);                
            }
    
            else if ( IS_CLASS(wch, CLASS_VAMPIRE) && wch->pcdata->stats[UNI_GEN] == 1 )
            sprintf( kav, " %sMaster Vampire%s", openb, closeb );
        else if (IS_CLASS(wch, CLASS_NAGA) && wch->pcdata->stats[UNI_GEN] == 1 )
            sprintf( kav, " %sNaga%s", openb, closeb );
            else if ( IS_CLASS(wch, CLASS_VAMPIRE) && wch->clan != NULL )
            {
            bool get_age = FALSE;
            char clanname[20];
    
            if (IS_SET(wch->special, SPC_INCONNU))
                get_age = TRUE;
            else if (IS_SET(wch->special, SPC_ANARCH))
                get_age = TRUE;
            else if (strlen(wch->clan) < 2)
                get_age = TRUE;
            else if (wch->pcdata->stats[UNI_GEN] == 2)
                sprintf( kav, " %sFounder of %s%s", openb, wch->clan, closeb );
            else if (IS_SET(wch->special, SPC_PRINCE) && wch->sex == SEX_FEMALE)
                sprintf( kav, " %s%s Princess%s", openb, wch->clan, closeb );
            else if (IS_SET(wch->special, SPC_PRINCE))
                sprintf( kav, " %s%s Prince%s", openb, wch->clan, closeb );
            else get_age = TRUE;
            if (get_age)
            {
                if (IS_SET(wch->special, SPC_INCONNU))
                strcpy( clanname, "Inconnu" );
                else if (IS_SET(wch->special, SPC_ANARCH))
                strcpy( clanname, "Anarch" );
                else if (strlen(wch->clan) < 2)
                strcpy( clanname, "Caitiff" );
                else
                strcpy( clanname, wch->clan );
                if (wch->pcdata->stats[UNI_GEN] == 2)
                sprintf( kav, " %s%s Antediluvian%s", openb, clanname, closeb );
                else switch ( wch->pcdata->rank )
                {
                default:
                sprintf( kav, " %s%s Childe%s", openb, clanname, closeb );
                break;
                case AGE_NEONATE:
                sprintf( kav, " %s%s Neonate%s", openb, clanname, closeb );
                break;
                case AGE_ANCILLA:
                sprintf( kav, " %s%s Ancilla%s", openb, clanname, closeb );
                break;
                case AGE_ELDER:
                sprintf( kav, " %s%s Elder%s", openb, clanname, closeb );
                break;
            case AGE_METHUSELAH:
                sprintf( kav, " %s%s Methuselah%s", openb, clanname, closeb );
                break;
                }
            }
            }
	else if ( IS_CLASS(wch, CLASS_GOD))
            sprintf( kav, " %s#GGOD%s", openb, closeb );
        else if ( IS_CLASS(wch, CLASS_NAGA))
             sprintf( kav, " %sNaga%s", openb, closeb );
            else if ( IS_CLASS(wch, CLASS_MAGE) )
            {
            if (wch->pcdata->powers[MPOWER_RUNE0] == RED_MAGIC)
                strcpy( mage_col, "#RRed" );
            else if (wch->pcdata->powers[MPOWER_RUNE0] == BLUE_MAGIC)
                strcpy( mage_col, "#BBlue" );
            else if (wch->pcdata->powers[MPOWER_RUNE0] == GREEN_MAGIC)
                strcpy( mage_col, "#GGreen" );
            else if (wch->pcdata->powers[MPOWER_RUNE0] == YELLOW_MAGIC)
                strcpy( mage_col, "#YYellow" );
            else strcpy( mage_col, "#PPurple" );
    
            if (wch->pcdata->stats[UNI_GEN] == 1)
                sprintf( kav, " %s#WGrand Archmage%s", openb, closeb );
            else if (wch->level == LEVEL_APPRENTICE)
                sprintf( kav, " %s%s Apprentice%s", openb, mage_col, closeb );
            else if (wch->level == LEVEL_MAGE)
                sprintf( kav, " %s%s Mage%s", openb, mage_col, closeb );
            else if (wch->level == LEVEL_ARCHMAGE)
                sprintf( kav, " %s%s Archmage%s", openb, mage_col, closeb);
            }
            else if (IS_CLASS(wch,CLASS_NYMPH) && wch->pcdata->stats[UNI_GEN]==1)
            {
            if (wch->sex == SEX_FEMALE)
                sprintf(kav, " %s#gNymph Goddess%s#-", openb, closeb);
            else if (wch->sex == SEX_MALE)
                sprintf(kav, " %s#gFaun Chief%s#-", openb, closeb);
            }
            else if (IS_CLASS(wch, CLASS_NYMPH))
            {
            if (wch->sex == SEX_FEMALE)
                sprintf(kav, " %s#gNymph%s#-", openb, closeb);
            else if (wch->sex == SEX_MALE)
		    sprintf(kav, " %s#gFaun%s#-", openb, closeb);
            }
            else if ( IS_CLASS(wch, CLASS_ZOMBIE) )
            {
            if (IS_SET(wch->special, SPC_PRINCE))
                sprintf( kav, " %s#yZombie Master%s", openb, closeb);
            else
                sprintf( kav, " %s#yZombie%s", openb, closeb);
            }
              else
            strcpy( kav, "#-" );
        }


        if (firstimm) 
        {
           sprintf(buf, "   #B-= #RImmortals #B=-#-\n\r%-14s", wch->name);
           firstimm = FALSE;
        }
        else if (firstmortal)
        {
           sprintf(buf, "   #B-= #RMortals #B=-#-\n\r%-14s", wch->name);
           firstmortal = FALSE;
        }
        else 
        {
           sprintf(buf, "%-14s", wch->name);
        }
        aprintf(D "%s" D "%s" D "%s %s%s", buf, class, wch->name, wch->pcdata->title,kav);
        }
     }
    }

}

/* the commands */
void do_achat(CHAR_DATA *ch, char *argument)
{
  char buf[MAX_STRING_LENGTH];
  if (IS_SET(ch->stuff[1], NO_ACHAT) || IS_SET(ch->stuff[1], ACHAT_BAN))
  {
     send_to_char("You can't use achat!!\n\r",ch);
     return;
  }
  if (IS_AFFECTED(ch, AFF_POLYMORPH))
     sprintf(buf, "%s", ch->morph);
  else sprintf(buf, "%s", ch->name);

  if (argument[0] == '\0')
    send_to_char("What would you like to chat?\n\r",ch);
  else
  {
    aprintf("%c" D "%c" D "%s" D "%s" D "%s",
    TO_ALL, CHAT, MYMUD, buf, argument);
  }
  return;
}

void do_acode(CHAR_DATA *ch, char *argument)
{
  if (IS_SET(ch->stuff[1], NO_ACHAT) || IS_SET(ch->stuff[1], ACHAT_BAN))
  {
     send_to_char("You can't use achat!!\n\r",ch);
     return;
  }

  if (argument[0] == '\0')
    send_to_char("What would you like to chat?\n\r",ch);
  else
  {
    aprintf("%c" D "%c" D "%s" D "%s" D "%s",
    TO_ALL, ACODE, MYMUD, ch->name, argument);
  }
  return;
}

void do_agod(CHAR_DATA *ch, char *argument)
{
  if (IS_SET(ch->stuff[1], NO_ACHAT) || IS_SET(ch->stuff[1], ACHAT_BAN))
  {
     send_to_char("You can't use achat!!\n\r",ch);
     return;
  }

  if (argument[0] == '\0')
    send_to_char("What would you like to chat?\n\r",ch);
  else
  {
    aprintf("%c" D "%c" D "%s" D "%s" D "%s",
    TO_ALL, AGOD, MYMUD, ch->name, argument);
  }
  return;
}


void do_areply(CHAR_DATA *ch, char *argument)
{
  char buf[MAX_STRING_LENGTH];
  sprintf(buf, "%s %s", ch->unused2, argument);
  do_atell(ch, buf);
}


void do_atell(CHAR_DATA *ch, char *argument)
{
  char buf[MAX_STRING_LENGTH];
  char argme[MAX_STRING_LENGTH];
  char *arg1;
  char arg2[MAX_STRING_LENGTH];
  char arg3[MAX_STRING_LENGTH];

  if (IS_SET(ch->stuff[1], NO_ACHAT) || IS_SET(ch->stuff[1], ACHAT_BAN))
  {
     send_to_char("You can't use achat!!\n\r",ch);
     return;
  }


  if (argument[0] == '\0')
  {
    send_to_char("Usage: ATell player@mud [message]\n\r",ch);
    return;
  }

  striptext2(argument,argme);
  if (noarg2)
  {
    send_to_char("Usage: ATell player@mud [message]\n\r",ch);
    return;
  }


  arg1 = get_arg2(argument);
  arg1 = one_argument(arg1, arg2);
  arg1 = one_argument(arg1, arg3);
  sprintf(arg3, "%s %s", arg3, arg1);
  arg1 = argument;
  arg3[0] = UPPER(arg3[0]);


  if (arg1[0] == '\0' || arg2[0] == '\0' || arg3[0] == '\0')
  {
    send_to_char("Usage: ATell player@mud [message]\n\r",ch);
    return;
  }
  else
  {
    if (arg1 == '\0' || arg2 == '\0' || arg3[0] == '\0')
    {
      send_to_char("What do you want to atell them?\n\r",ch);
      return;
    }
    aprintf("%c" D "%s" D "%c" D "%s" D "%s" D "%s" D "%s",
    TO_MUD, arg2, TELL, ch->name, arg1, MYMUD, arg3);
    arg1[0] = UPPER(arg1[0]);
    arg2[0] = UPPER(arg2[0]);
    sprintf(buf,"#rYou atell %s#R@#r%s#R: #r%s\n\r", arg1, arg2, arg3);
    send_to_char(buf,ch);
  }
}

void do_aemote(CHAR_DATA *ch, char *argument)
{

   char buf[MAX_STRING_LENGTH];
   sprintf(buf, ":%s", argument);
   do_achat(ch, buf);
}


void do_amessage(CHAR_DATA *ch, char *argument)
{
  char buf[MAX_STRING_LENGTH];
  char argme[MAX_STRING_LENGTH];
  char *arg1;
  char arg2[MAX_STRING_LENGTH];
  char arg3[MAX_STRING_LENGTH];

  if (IS_SET(ch->stuff[1], NO_ACHAT) || IS_SET(ch->stuff[1], ACHAT_BAN))
  {
     send_to_char("You can't use achat!!\n\r",ch);
     return;
  }


  if (ch->level < 12)
  {
  send_to_char("Huh?\n\r",ch);
  return;
  }

  if (argument[0] == '\0')
  {
    send_to_char("Usage: AMessage player@mud [message]\n\r",ch);
    return;
  }

  striptext2(argument,argme);
  if (noarg2)
  {
    send_to_char("Usage: AMessage player@mud [message]\n\r",ch);
    return;
  }


  arg1 = get_arg2(argument);
  arg1 = one_argument(arg1, arg2);
  arg1 = one_argument(arg1, arg3);
  sprintf(arg3, "%s %s", arg3, arg1);
  arg1 = argument;



  if (arg1[0] == '\0' || arg2[0] == '\0' || arg3[0] == '\0')
  {
    send_to_char("Usage: ATell player@mud [message]\n\r",ch);
    return;
  }
  else
  {
    if (arg1 == '\0' || arg2 == '\0' || arg3[0] == '\0')
    {
      send_to_char("What do you want to atell them?\n\r",ch);
      return;
    }
    aprintf("%c" D "%s" D "%c" D "%s" D "%s" D "%s",
    TO_MUD, arg2, MSG, arg1, MYMUD, arg3);
    sprintf(buf,"#rAMessage to #R%s#r@#R%s#r: #R%s\n\r", arg1, arg2, arg3);
    send_to_char(buf,ch);
  }
}

void abercmd(char type, char *text)
{
  char *arg1;
  char *arg2;
  char *arg3;
  char *arg4;
  char buf[MAX_STRING_LENGTH];

  char *packet = aber2diku(text);


  switch (type)
  {
  case MUDLIST:
    amudlist(packet);
    return;
  case ABERMAIL:
    receive_abermail(packet);
    return;
  case RWHO:
    receive_awho(packet);
    return;
  }   

  arg1 = packet;
  arg2 = get_arg(arg1);
  arg3 = get_arg(arg2);
  arg4 = get_arg(arg3);

  sprintf(buf,"%d : %s : %s : %s : %s", type, arg1, arg2, arg3, arg4);
  switch (type)
  {
  case KICK:
    kick_player(arg1, arg2, arg3);
    break;
  case FILEPAGE:
/*    afilepage(arg1, arg2, arg3);*/
    break;
  case AVERSION:
    aversion(arg1, arg2, arg3);
    break;
  case MSG:
    amessage(arg1, arg2, arg3);
    break;
  case TELL:
    atell(arg1, arg2, arg3, arg4);
    break;
  case AVERREQ:
    aver_reply(arg1, arg2);
    break;
  case WHO:
    send_awho(arg1, arg2);
    break;
  case CHAT:
  case ACODE:
  case AGOD:
    achat(type, arg1, arg2, arg3);
    break;
  case INFOMSG:
    ainfo(arg1, arg2);
    break;
  case AUTH:
    if (*packet == 'Y')
      auth_received(TRUE);
    else
      auth_received(FALSE);
    break;
  }
}

void do_ainfo(CHAR_DATA *ch, char *argument)
{
  if (IS_SET(ch->stuff[1], NO_ACHAT) || IS_SET(ch->stuff[1], ACHAT_BAN))
  {
     send_to_char("You can't use achat!!\n\r",ch);
     return;
  }

  if (ch->level < 12)
  {
    return;
  }
  if (argument[0] == '\0')
    send_to_char("What should the message be?\n\r",ch);
  else
    aprintf("%c" D "%c" D "%s" D "%s", TO_ALL, INFOMSG, MYMUD, argument);
}

void do_aautocon(CHAR_DATA *ch, char *argument)
{
  char buf[MAX_STRING_LENGTH];
  if (ch->level < 12)
  {
    return;
  }
  auto_restart = auto_restart ? FALSE : TRUE;

  sprintf(buf, "AberChat Auto Connect is %s.\n\r", auto_restart ? "On" : "Off");
  send_to_char(buf,ch);
}

void do_aboot(CHAR_DATA *ch, char *argument)
{
  if (ch->level < 12)
  {
    return;
  }

  switch(aberchat_boot(fCopyOver))
  {
    case 0:
    send_to_char("Failed.\n\r",ch);
    break;
    case 1:
    send_to_char("Connected to AberChat Server.\n\r",ch);
    break;
    case 2:
    send_to_char("Already running AberChat.\n\r",ch);
    break;
  }

  return;
}

void do_ashutdown(CHAR_DATA *ch, char *argument)
{
  if (ch->level < 12)
  {
    return;
  }
  if (!aberchat_shutdown())
  {
    send_to_char("Aberchat not running.\n\r",ch);
  }
  else
  {
    aberchat_shutdown();
    send_to_char("Disconnected from AberChat server.\n\r",ch);
  }
  return;
}

/* Mudlist request */
void do_amudlist(CHAR_DATA *ch, char *argument)
{
  if (IS_SET(ch->stuff[1], NO_ACHAT) || IS_SET(ch->stuff[1], ACHAT_BAN))
  {
     send_to_char("You can't use achat!!\n\r",ch);
     return;
  }

  aprintf("%c" D "%s" D "%c" D "%s", TO_MUD, MYMUD, MUDLIST, ch->name);
}

void do_noachat(CHAR_DATA *ch, char *argument)
{
   if (IS_SET(ch->stuff[1], NO_ACHAT))
      REMOVE_BIT(ch->stuff[1], NO_ACHAT);
   else
      SET_BIT(ch->stuff[1], NO_ACHAT);

   send_to_char("Ok.\n\r",ch);


}

/****************************************************************
 * cmd_awho() sends a WHO request to the specified mud.  The mud *
 * then sends a response packet, in send_awho(), and the packet *
 * is received/displayed in receive_awho()                      *
 ****************************************************************/

void do_awho(CHAR_DATA *ch, char *argument)
{
  if (IS_SET(ch->stuff[1], NO_ACHAT) || IS_SET(ch->stuff[1], ACHAT_BAN))
  {
     send_to_char("You can't use achat!!\n\r",ch);
     return;
  }

  if (argument[0] == '\0')
    send_to_char("Which mud?\n\r",ch);
  else
    aprintf("%c" D "%s" D "%c" D "%s" D "%s",
    TO_MUD, argument, WHO, MYMUD, ch->name);
}

/********************************************************************
 * cmd_aversion() sends the current version to the aberchat server, *
 * or makes a request to another mud for it's version.              *
 ********************************************************************/


/* the various support functions and stuff that deals with the
 * aberchat protocol itself
 */



void do_akick(CHAR_DATA *ch, char *argument)
{
    char *mud, *item1;
    char mudcheck[MAX_STRING_LENGTH];
    char buf[MAX_STRING_LENGTH];

    if (argument[0] == '\0')
    {
       send_to_char("Usage: AMessage player@mud [message]\n\r",ch);
       return;
    }

    striptext(argument,mudcheck);
    if (noarg2)
    {
      send_to_char("Usage: AMessage player@mud [message]\n\r",ch);
      return;
    }
    item1 = argument;
    mud = get_arg2(item1);
    if (item1[0] != '\0' && mud[0] != '\0' )
    {
	aprintf("%c" D "%s" D "%c" D "%s" D "%s" D "%s",
	   TO_MUD, mud, KICK, ch->name, item1, MYMUD);
	sprintf(buf,"ABERCHAT: %s has akicked %s@%s", ch->name, item1, mud);
	log_string(buf);
    }
}    

void do_unakick( CHAR_DATA *ch, char *argument )
{
    char arg[MAX_INPUT_LENGTH];
    char buf[MAX_STRING_LENGTH];
    CHAR_DATA *victim;

    sprintf(buf,"%s: UnAkick %s",ch->name,argument);

    one_argument( argument, arg );

    if ( arg[0] == '\0' )
    {
	send_to_char( "Freeze whom?\n\r", ch );
	return;
    }

    if ( ( victim = get_char_world( ch, arg ) ) == NULL )
    {
	send_to_char( "They aren't here.\n\r", ch );
	return;
    }

    if ( IS_NPC(victim) )
    {
	send_to_char( "Not on NPC's.\n\r", ch );
	return;
    }

    if (IS_SET(victim->act, PLR_GODLESS) && get_trust(ch) < NO_GODLESS
	&& !IS_SET(ch->extra , EXTRA_ANTI_GODLESS))
    {
	send_to_char( "You failed.\n\r", ch );
	return;
    }

    if ( get_trust( victim ) >= get_trust( ch ) )
    {
	send_to_char( "You failed.\n\r", ch );
	return;
    }

    if ( IS_SET(victim->stuff[1], ACHAT_BAN) )
    {
      REMOVE_BIT(victim->stuff[1], ACHAT_BAN);
      send_to_char( "You can use AberChat.\n\r", victim );
      send_to_char( "KICK removed.\n\r", ch );
    }
    else send_to_char( "They have not been KICKed!\n\r",ch);

    save_char_obj( victim );

    return;
}


void do_aversion(CHAR_DATA *ch, char *argument)
{
  char buf[MAX_STRING_LENGTH];
  if (argument[0] == '\0')
    aprintf("%c" D "%s" D "%c" D "%s" D "%s",
      TO_MUD, MYMUD, AVERSION, ch->name, CLIENT_VERSION);
  else
  {
     sprintf(buf, "Version for MUD %s (if no response, client is pre-4.20):\n\r", argument);
     send_to_char(buf, ch);
     aprintf("%c" D "%s" D "%c" D "%s" D "%s",
         TO_MUD, argument, AVERREQ, MYMUD, ch->name);
  }
}
